#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
# === HardwareInformation::GUI::Gtk::MountedHarddiscs
# =========================================================================== #
# require 'hardware_information/gui/gtk3/gtk3_standalone/gtk3_standalone.rb'
# HardwareInformation::GUI::Gtk::MountedHarddiscs.run
# =========================================================================== #
require 'gtk_paradise/require_gtk3'

module HardwareInformation

module GUI

module Gtk

class MountedHarddiscs < ::Gtk::Box # === HardwareInformation::GUI::Gtk::MountedHarddiscs 

  require 'gtk_paradise/requires/require_the_base_module.rb'
  include ::Gtk::BaseModule

  require 'hardware_information/gui/shared_code/mounted_harddiscs/mounted_harddiscs_module.rb'
  include HardwareInformation::GUI::MountedHarddiscsModule

  # ========================================================================= #
  # === initialize
  # ========================================================================= #
  def initialize(
      commandline_arguments = ARGV,
      run_already           = true
    )
    super(:vertical)
    reset
    set_commandline_arguments(
      commandline_arguments
    )
    run if run_already
  end

  # ========================================================================= #
  # === reset                                                     (reset tag)
  # ========================================================================= #
  def reset
    reset_the_internal_variables
    infer_the_namespace
    # ======================================================================= #
    # === @configuration
    # ======================================================================= #
    @configuration = [true, __dir__, namespace?]
    # ======================================================================= #
    # === Set the title, width, height and the font in use.
    # ======================================================================= #
    title_width_height_font(TITLE, WIDTH, HEIGHT, USE_THIS_FONT)
    use_gtk_paradise_project_css_file 
    infer_the_size_automatically
    reset_the_shared_module
  end

  # ========================================================================= #
  # === create_skeleton                            (create tag, skeleton tag)
  # ========================================================================= #
  def create_skeleton
  end

  # ========================================================================= #
  # === connect_skeleton                                        (connect tag)
  # ========================================================================= #
  def connect_skeleton
    abort_on_exception
    minimal(
      gtk_left_aligned_label('Available harddiscs:')
    )
  end

  # ========================================================================= #
  # === run                                                         (run tag)
  # ========================================================================= #
  def run
    super()
    do_capture_and_analyse_the_output_determining_which_harddiscs_are_available
  end

  # ========================================================================= #
  # === HardwareInformation::GUI::Gtk::MountedHarddiscs.run
  # ========================================================================= #
  def self.run(
      i = ARGV
    )
    require 'gtk_paradise/app/app.rb'
    _ = ::HardwareInformation::GUI::Gtk::MountedHarddiscs.new(i)
    r = ::Gtk.run
    r << _
    r.automatic_size_then_automatic_title
    r.enable_quick_exit
    r.top_left_then_run
  end

end; end; end; end

if __FILE__ == $PROGRAM_NAME
  HardwareInformation::GUI::Gtk::MountedHarddiscs.run
end