#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
# === HardwareInformation::PurchasedHardware
#
# This module has been primarily written to support the old content
# shown in the old .cgi file. By having this available as a module
# we can, in principle, adapt this easily into sinatra or rails as
# well, so we gain more flexibility by using a module here.
# =========================================================================== #
# require 'hardware_information/misc/purchased_hardware/purchased_hardware.rb'
# include HardwareInformation::PurchasedHardware
# =========================================================================== #
class HardwareInformation

module PurchasedHardware

  require 'yaml'

  # ========================================================================= #
  # === HardwareInformation::PurchasedHardware.title?
  # ========================================================================= #
  def self.title?
    'Meine Hardware'
  end

  # ========================================================================= #
  # === HardwareInformation::PurchasedHardware.body_css_class
  # ========================================================================= #
  def self.body_css_class
    'BG_BLACK pad0_4em'
  end

  # ========================================================================= #
  # === HardwareInformation::PurchasedHardware.body_css_style
  # ========================================================================= #
  def self.body_css_style
    return '
border-top:  3px solid orange;
border-left: 3px solid orange;
color: #ceffce;
width: 100%;'
  end

  # ========================================================================= #
  # === COLOUR_PURCHASED_AT_THIS_DATE
  # ========================================================================= #
  COLOUR_PURCHASED_AT_THIS_DATE = 'mistyrose' # wann ich es gekauft habe

  # ========================================================================= #
  # === @total_cost
  #
  # Keep track of the total cost, in euro.
  # ========================================================================= #
  @total_cost = 0

  # ========================================================================= #
  # === HardwareInformation::PurchasedHardware.add_to_the_total_cost
  # ========================================================================= #
  def self.add_to_the_total_cost(i)
    @total_cost += i.to_f
  end; self.instance_eval { alias add_to_total_cost add_to_the_total_cost } # === HardwareInformation::PurchasedHardware.add_to_total_cost

  # ========================================================================= #
  # === HardwareInformation::PurchasedHardware.total_cost?
  # ========================================================================= #
  def self.total_cost?
    @total_cost
  end

  # ========================================================================= #
  # === MAIN_DIV
  #
  # CSS-related Constants are defined next.
  # ========================================================================= #
  MAIN_DIV = 'pad0_5em mart0_2em'

  # ========================================================================= #
  # === LINUX_YAML
  #
  # A hardcoded path.
  # ========================================================================= #
  LINUX_YAML = '/home/x/data/PC/OS/LINUX/yaml/'

  # ========================================================================= #
  # === HardwareInformation::PurchasedHardware.linux_yaml_directory?
  # ========================================================================= #
  def self.linux_yaml_directory?
    LINUX_YAML
  end

  # ========================================================================= #
  # === HardwareInformation::PurchasedHardware.file_computer_hardware?
  #
  # All the important data is stored in the following .yml file:
  #
  #   bl /home/x/DATA/PC/OS/LINUX/yaml/computer_hardware.yml
  #
  # ========================================================================= #
  def self.file_computer_hardware?
    '/home/x/data/personal/yaml/my_hardware/my_hardware.yml'
  end

  # ========================================================================= #
  # === HardwareInformation::PurchasedHardware.file_my_hardware
  #
  # See:
  #
  #   bl /home/x/data/personal/yaml/my_hardware/my_hardware.yml
  # 
  # ========================================================================= #
  def self.file_my_hardware
    "/home/x/data/personal/yaml/my_hardware/my_hardware.yml"
  end

  # ========================================================================= #
  # === HardwareInformation::PurchasedHardware.my_hardware
  #
  # This method will return the hash I use for the hardware I have
  # purchased over the years.
  # ========================================================================= #
  def self.my_hardware(i = file_my_hardware)
    YAML.load_file(i)
  end

  # ========================================================================= #
  # === main_dataset?
  # ========================================================================= #
  def main_dataset?
    ::HardwareInformation::PurchasedHardware.my_hardware
  end

  # ========================================================================= #
  # === HardwareInformation::PurchasedHardware.return_dataset_from_the_file_computer_hardware
  #
  # This will return the dataset stored in the .yml file.
  # ========================================================================= #
  def self.return_dataset_from_the_file_computer_hardware
    _ = file_computer_hardware?
    if File.exist? _
      return YAML.load_file(_)
    end
  end

  # ========================================================================= #
  # === @array_date_bought_at
  # ========================================================================= #
  @array_date_bought_at = []

  # ========================================================================= #
  # === HardwareInformation::PurchasedHardware.add_bought_at
  #
  # This method will only add non-nil values.
  # ========================================================================= #
  def self.add_bought_at(i)
    unless i.nil?
      @array_date_bought_at << i
    end
  end

  # ========================================================================= #
  # === HardwareInformation::PurchasedHardware.bought_at?
  # ========================================================================= #
  def self.bought_at?
    return @array_date_bought_at
  end

end; end