#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
# require 'hardware_information/www/embeddable_interface.rb'
# include HardwareInformation::EmbeddableInterface
# =========================================================================== #
class HardwareInformation

module EmbeddableInterface

  require 'hardware_information/misc/purchased_hardware/purchased_hardware.rb'

  # ========================================================================= #
  # === HardwareInformation::EmbeddableInterface.routes?
  #
  # Define all legal routes via this Array. This Array will then be used
  # to add more routes to any sinatra-application that needs it.
  # ========================================================================= #
  def self.routes?
    [
      'hardware_information'
    ]
  end

  # ========================================================================= #
  # === return_sinatra_hardware_information
  # ========================================================================= #
  def return_sinatra_hardware_information
    hash = HardwareInformation::PurchasedHardware.my_hardware
    _ = ''.dup
    hash.each_pair {|key, inner_hash|
      _ << "#{key}<br>"
      _ << '<span style="margin-left: 1em">bought at: '+
           inner_hash['bought_at'].to_s+'</span><br>'
      _ << '<br>'
    }
    return _
  end

end

# =========================================================================== #
# === HardwareInformation.embeddable_interface
# =========================================================================== #
def self.embeddable_interface
  object = Object.new
  object.extend(::HardwareInformation::EmbeddableInterface)
  return object
end

end