#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
# http://localhost/programming/ruby/src/hardware_information/lib/hardware_information/www/my_hardware_for_sinatra.rb
# =========================================================================== #
require 'cyberweb/and_sinatra_base.rb'

class HardwareInformation

class SinatraMyHardware < ::Sinatra::Base # === HardwareInformation::SinatraMyHardware

  # ========================================================================= #
  # === USE_THIS_PORT
  # ========================================================================= #
  USE_THIS_PORT = '4567'

  set :port, USE_THIS_PORT

  # ========================================================================= #
  # === initialize
  # ========================================================================= #
  def initialize
    super()
    target = "http://localhost:#{USE_THIS_PORT}/"
    Cyberweb.try_to_open_this_URL_via_the_browser(target, USE_THIS_PORT)
  end

  # ========================================================================= #
  # === /
  #
  # Usage Example:
  #
  #   http://localhost:4567/
  #
  # ========================================================================= #
  get('/'){
    return Cyberweb::WebObject.evaluate_from_the_same_named_file_then_serve(
      :do_not_display_anything,
      HardwareInformation.project_base_dir?+'www/my_hardware_for_sinatra.rb'
    )
  }

  # ========================================================================= #
  # === HardwareInformation::SinatraMyHardware.start_sinatra_interface
  # ========================================================================= #
  def self.start_sinatra_interface
    ::HardwareInformation::SinatraMyHardware.run!
  end

end

# =========================================================================== #
# === HardwareInformation.start_sinatra_interface
# =========================================================================== #
def self.start_sinatra_interface
  puts 'Trying to start the sinatra-interface of HardwareInformation next.'
  HardwareInformation::SinatraMyHardware.start_sinatra_interface
end

end

if __FILE__ == $PROGRAM_NAME
  HardwareInformation::SinatraMyHardware.start_sinatra_interface
end # hardwareinformation --sinatra